#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 100

typedef float rzecz;

int n;
rzecz tab[MAX][2][2];
int pole[MAX*2][MAX*2];
rzecz sortx[MAX*2];
rzecz sorty[MAX*2];

int cmp_rzecz(const void *a, const void *b) {
  return *((rzecz *) a) - *((rzecz *) b);
}

int szuk(rzecz a[], rzecz x) {
  int i = 0;

  while(1) {
    if (a[i] == x) return i;
    i++;
  }
}

rzecz solve() {
  int i;
  int x1,y1,x2,y2,x,y;
  rzecz sum;

  for (i = 0; i < n; i++) {
    sortx[2*i + 0] = tab[i][0][0];
    sortx[2*i + 1] = tab[i][1][0];

    sorty[2*i + 0] = tab[i][0][1];
    sorty[2*i + 1] = tab[i][1][1];
  }

  qsort(sortx, 2*n, sizeof(rzecz), cmp_rzecz);
  qsort(sorty, 2*n, sizeof(rzecz), cmp_rzecz);
  memset(pole, 0, sizeof(pole));

  for (i = 0; i < n; i++) {
    x1 = szuk(sortx, tab[i][0][0]);
    x2 = szuk(sortx, tab[i][1][0]);

    y1 = szuk(sorty, tab[i][0][1]);
    y2 = szuk(sorty, tab[i][1][1]);

    for (x = x1; x < x2; x++) {
      for (y = y1; y < y2; y++) {
        pole[x][y] = 1;
      }
    }

    sum = 0.0;
    for (x = 0; x < n - 1; x++) {
      for (y = 0; y < n - 1; y++) {
        if (pole[x][y]) {
          sum += (sortx[x+1] - sortx[x]) * (sorty[y+1] - sorty[y]);
        }
      }
    }
  }


/* ------------------- */
printf("\nTeraz sortx (n = %i):\n", n);
for(i = 0; i < 2*n; i++) {
  printf(" %.2f", sortx[i]);
}
printf("\nTeraz sorty:\n");
for(i = 0; i < 2*n; i++) {
  printf(" %.2f", sorty[i]);
}
printf("\nTeraz tab[]\n");
for(x = 0; x < n; x++) {
  printf("[%.2f,%.2f - %.2f,%.2f]", tab[x][0][0], tab[x][0][1],
tab[x][1][0], tab[x][1][1]);
}
printf("\n");
printf("\nTeraz pole[][]:\n");
for(y = 0; y < 2*n; y++) {
  for(x = 0; x < 2*n; x++) {
    printf("%i ", pole[x][y]);
  }
  printf("\n");
}



  return sum;
}

int main() {
  FILE *src;
  int zest = 1;
  int d;

  src = fopen("atlantis.in", "rt");
  while(1) {
    fscanf(src, "%i", &n);
    if (!n) break;
    for(d = 0; d < n; d++) {
      fscanf(src, "%f %f %f %f", &tab[d][0][0], &tab[d][0][1],
                                 &tab[d][1][0], &tab[d][1][1]);
    }
    printf("Test case #%i\nTotal explored area: %.2f\n\n", zest++, solve());
  }
  fclose(src);
  return 0;
}



Teraz sortx (n = 2):
 10.00 15.00 20.00 25.00
Teraz sorty:
 10.00 15.00 20.00 25.50
Teraz tab[]
[10.00,10.00 - 20.00,20.00][15.00,15.00 - 25.00,25.50]

Teraz pole[][]:
1 1 0 0 
1 1 1 0 
0 1 1 0 
0 0 0 0 
Test case #1
Total explored area: 25.00

