#include<iostream.h>
#include<string.h>

class int_matrix {
  protected:
    int m,n;
    int** matrix;
    void allocate();
    void release();
public:
  int_matrix(int m=0,int n=0);
  ~int_matrix();
  void change_size(int m, int n);
  int& operator()(int i,int j) {return matrix[i-1][j-1];}
  void print();
  int get_m() {return m;}
  int get_n() {return n;}
    
};


int_matrix::int_matrix(int _m, int _n)
{
  m=_m;
  n=_n;
  allocate();
}

void int_matrix::allocate()
{
  if ((m!=0)&&(n!=0)) {
    matrix =  new int*[m];
    for (int i=0;i<m;i++){
      matrix[i]=new int[n];
      memset(matrix[i],0,n*sizeof(int));
    }
  }
}

void int_matrix::release()
{
  if ((n!=0)&&(m!=0)){
    for (int i=0;i<m;i++) {
      delete [] matrix[i];
    }
    delete [] matrix;
  }
  m=n=0;
}

int_matrix::~int_matrix() {
  release();
}

void int_matrix::change_size(int _m, int _n) {
  release();
  m=_m;
  n=_n;
  allocate();
}

void int_matrix::print()
{
  for (int i=0;i<m;i++) {
    for (int j=0;j<n;j++) {
      cout << matrix[i][j] << "/t";
    }
    cout << endl;
  }
}

class int_vector {
protected:
  int n;
  int* vector;
  void allocate();
  void release();
public:
  int_vector(int n=0);
  ~int_vector();
  void change_size(int n);
  int& operator()(int i){return vector[i-1];}
  void print();
  int get_n() {return n;}
  
};


void int_vector::allocate()
{
  if (n!=0) {
    vector=new int[n];
    memset(vector,0,n*sizeof(int));
  }
}

void int_vector::release()
{
  if (n!=0) {
    delete [] vector;
    n=0;
  }
}

int_vector::int_vector(int _n)
{
  n=_n;
  allocate();
}

int_vector::~int_vector()
{
  release();
}

void int_vector::change_size(int _n)
{
  release();
  n=_n;
  allocate();
}

void int_vector::print()
{
  for (int i=0;i<n;i++) {
    cout << vector[i] << endl;
  }
}

class fifo_queue:public int_vector { 
protected:
  int size, max, head, tail;
public:
  void resize(int n);
  fifo_queue (int _max=1):max(_max), int_vector(_max), size(0), head(0), tail(0) {}
  int full() {return (size==max);}
  int empty() {return (size==0);}
  void enqueue(int n);
  int dequeue();
  int count() {return size;}
};


void fifo_queue::resize(int _n)
{
  change_size(_n);
  max=_n;
  tail=0;
  head=0;
  size=0;
}

void fifo_queue::enqueue(int n) 
{
  if (full()) throw;
  vector[tail]=n;
  tail++;
  tail%=max;
  size++;
}

int fifo_queue::dequeue()
{
  if (empty()) return (-1);
  int result=vector[head];
  head++;
  head%=max;
  size--;
  return result;
}


struct train {
  unsigned int deptime, arrtime;
  union {
    struct time {
      unsigned char source, dest;
    };
    unsigned int t;
  };
};

train t[99001];

int_vector d(100);
int_matrix g(100);
char* names[101];
int start;
int n, trains;
int edges=0;


int citynr(char* name) 
{
  for (int i=1;i<=n;i++) {
    if (strcmp(name,names[i])==0) return i;
  }
  return 0;
}

void add(unsigned int d, unsigned int a, unsigned char snr, unsigned char dnr)
{
  t[edges].deptime=d;
  t[edges].arrtime=a;
  t[edges]..source=snr;
  t[edges].time.dest=dnr;
  edges++;
}

void fillg()
{
  int u, v, lastu, lastv;
  lastu=t[1].source;
  lastv=t[1].dest;
  g(lastu, lastv)=1;
  for (int i=2;i<=edges;i++) {
    u=t[i].source;
    v=t[i].dest;
    if ((u!=lastu)||(v!=lastv)) {
      g(u,v)=i;
    }
    lastu=u;
    lastv=v;
  }
}

void wczytaj() 
{
  ifstream fin("railroad.in");
  fin>>n;
  for (int i=1; i<=n; i++) {
    fin>>names[i];
  }
  fin>>trains;
  int cities, deptime, arrtime, destnr, sourcenr;
  char* sourcename,destname;
  for (int i=0; i<trains; i++) {
    fin>>cities;
    fin>>deptime;
    fin>>sourcename;
    sourcenr=citynr(sourcename);
    for(int j=0;j<cities-1;j++) {
      fin >> arrtime;
      fin>>destname;
      destnr=citynr(destname);
      add(deptime,arrtime, sourcenr, destnr);
    }
  }
  
}


int main()
{
  
  return 0;
}
